;*****WINMAIN*******************************************************************
WMSTRUC STRUC
 msg MSG {}      ;message structure ****ALWAYS KEEP MSG STRUCTURE AT BEGINNING
 hAccel  DWORD ?
WMSTRUC ENDS

MAIN:
 XOR EBP,EBP           ;handy constant zero
 SUB ESP,WMSTRUC       ;make local space

 INVOKE GetModuleHandleA,EBP

 MOV ESI,EAX           ;now ESI=module handle
 MOV [hInst],EAX       ;tuck it away

;*****CLASS REGISTRATION********************************************************
 RPUSHIT @ szAppName,@ szAppName
; INVOKE GetStockObject,EBP               ;EBP=0=WHITE_BRUSH
; PUSHIT EAX
 RPUSHIT COLOR_WINDOW+1                   ;for window background color
; INVOKE CreateSolidBrush,EBP             ;EBP=0
;  PUSHIT EAX
 INVOKE LoadCursorA,EBP,IDC_ARROW
 RPUSHIT EAX                              ;cursor handle
; INVOKE LoadIconA,ESI,IDI_ICON
 INVOKE LoadIconA,ESI,@ szAppName         ;ESI=hInstance
 S1=CS_HREDRAW OR CS_VREDRAW
 RPUSHIT S1,@ WINCALLBACK,EBP,EBP,ESI,EAX ;ESI=hInst
 INVOKE RegisterClassA,ESP

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('Class registration failed.',0),EBP,EBP ;message and exit if failure
   JMP EXIT
 .ENDIF
ENDIF

 ADD ESP,10*DWORD                        ;balance stack from WNDCLASS
; ADD ESP,12*DWORD                        ;balance stack from WNDCLASSEX

;*****END OF CLASS REGISTRATION*************************************************

 INVOKE LoadAccelerators,ESI,@ szAppName ;ESI=hInstance
 MOV [ESP.WMSTRUC.hAccel],EAX

;*****WINDOW CREATION***********************************************************

 MOV ECX,CW_USEDEFAULT
 S1=WS_OVERLAPPEDWINDOW

 INVOKE CreateWindowExA,EBP,@ szAppName,EBP,S1,ECX,ECX,ECX,ECX,EBP,EBP,ESI,EBP ;EBP=0

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('Main CreateWindow call error',0),EBP,EBP ;message and exit if failure
   JMP EXIT
 .ENDIF
ENDIF

 MOV ESI,EAX           ;now ESI=hwnd=window handle

;*****END OF WINDOW CREATION****************************************************

 INVOKE ShowWindow,ESI,SW_SHOWNORMAL

 INVOKE UpdateWindow,ESI

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('UpdateWindow call error',0),EBP,EBP ;message and exit if failure
   JMP EXIT
 .ENDIF
ENDIF

 MOV EBX,ESP                    ;EBX=&WMSTRUC on stack

 .WHILE TRUE  ;beginning of message loop
   INVOKE GetMessageA,EBX,EBP,EBP,EBP ;
   TEST EAX,EAX

   IF DBUG
    JS GMERR ;jump out on GetMessage error
   ELSE
    JS EXIT  ;jump out on GetMessage error
   ENDIF

   .BREAK .IF ZERO? ;jump out on WM_QUIT message

   IF TRUE
   CMP [hDlgModeless],EBP
   JZ @F

   INVOKIT IsDialogMessage,[hDlgModeless],EBX ;ESI=dialog box handle,EBX=&msg
   TEST EAX,EAX
   .CONTINUE .IF !ZERO?
   ENDIF

   @@:
   IF TRUE
    INVOKE TranslateAccelerator,ESI,[EBX.WMSTRUC.hAccel],EBX ;EBX=&msg

    TEST EAX,EAX
    .CONTINUE .IF !ZERO?
   ENDIF

   INVOKE TranslateMessage,EBX ;EBX=&msg
   INVOKE DispatchMessageA,EBX ;EBX=&msg
 .ENDW                     ;repeat message loop

 MOV EAX,[ESP.WMSTRUC.msg.wParam]

EXIT:
 ADD ESP,WMSTRUC           ;recover local space

 INVOKE ExitProcess,EAX

IF DBUG
GMERR:                     ;display error message via message box & jmp to EXIT
 INVOKE MessageBox,ESI,TEXT('GetMessage call error',0),EBP,EBP ;message and exit if failure
 JMP EXIT
ENDIF
;*****END OF WINMAIN************************************************************
